{Enterprise Dynamics startup information}

if(StartingED, SoftStartED([]));


{Model information}

AddLayer([Main], 1, 1, 0);


{Load required atoms}

int011;
int035([Sink], pDir([Atoms\Sink.atm]));
int035([Queue], pDir([Atoms\Queue.atm]));
int035([Source], pDir([Atoms\Source.atm]));
int035([Transporter], pDir([Atoms\Transporter.atm]));
int035([Portal Crane], pDir([Atoms\Portal Crane.atm]));
int035([Ground Storage], pDir([Atoms\Ground Storage.atm]));
int035([Node Manipulator], pDir([Atoms\Node Manipulator.atm]));
int012;


{Atom: Portal Crane10}

sets;
AtomByName([Portal Crane], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Portal Crane'. Inheriting from BaseClass.]));
CreateAtom(a, s, [], 1, false);
int023([Portal Crane10], 1760767, 3120);
Set(Icon(a), 
	RegisterIcon(pDir([media\images\default.jpg]), [default.jpg]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\PortalCrane.ico]));
Set(DdbRec, [>craneexists:1.]);
int001(219);
SetLoc(12, 14, 0);
SetSize(7, 10, 6);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetAtt(1, 1);
SetAtt(2, 1);
SetAtt(3, 3);
int024;
SetStatus(1);
int018;


{Atom: X Direction}

sets;
AtomByName([X Direction], Main);
if(not(AtomExists), Error([Cannot find mother atom 'X Direction'. Inheriting from BaseClass.]));
CreateAtom(a, s, [], 1, false);
int023([X Direction], 0, 3072);
Set(Icon(a), 
	RegisterIcon(pDir([media\images\default.jpg]), [default.jpg]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\PortalCrane.ico]));
int001(220);
SetLoc(11, 0, 0);
SetSize(1, 1, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
int024;
SetStatus(0);
int018;


{Atom: Y Direction}

sets;
AtomByName([Y Direction], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Y Direction'. Inheriting from BaseClass.]));
CreateAtom(a, s, [], 1, false);
int023([Y Direction], 0, 3072);
Set(Icon(a), 
	RegisterIcon(pDir([media\images\default.jpg]), [default.jpg]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\PortalCrane.ico]));
int001(221);
SetLoc(0, 9.3788489367783, 0);
SetSize(1, 1, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
int024;
SetStatus(0);
int018;


{Atom: Crane}

sets;
AtomByName([Crane], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Crane'. Inheriting from BaseClass.]));
CreateAtom(a, s, [], 1, false);
int023([Crane], 255, 1074);
Set(Icon(a), 
	RegisterIcon(pDir([media\images\default.jpg]), [default.jpg]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\PortalCrane.ico]));
SetChannels(2, 2);
SetChannelRanges(1, 255, 1, 255);
int001(222);
int013(1, 0, true, false, 0, 0, [], []);
int013(2, 0, true, false, 0, 0, [], []);
SetLoc(0, 0, 1);
SetSize(1, 1, 4);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [1]);
SetExprAtt(2, [1]);
SetExprAtt(3, [1]);
SetExprAtt(4, [0.1]);
SetExprAtt(5, [0.1]);
SetExprAtt(6, [0.1]);
SetExprAtt(7, [0.1]);
SetExprAtt(8, [0.1]);
SetExprAtt(9, [0.1]);
SetExprAtt(10, [0]);
SetExprAtt(11, [0]);
SetAtt(12, 0);
SetAtt(13, 11);
SetAtt(14, 0);
SetAtt(15, 11);
SetAtt(16, 0);
SetAtt(17, 1);
SetExprAtt(18, [3]);
SetExprAtt(19, [1]);
SetAtt(20, 0);
SetAtt(21, 0);
SetAtt(22, 0);
SetAtt(23, 20);
SetAtt(24, 10);
SetAtt(25, 0);
SetAtt(26, 7);
SetAtt(27, 1);
SetAtt(28, 1);
SetAtt(29, 1);
SetAtt(30, 1);
SetAtt(31, 1);
SetAtt(32, 1);
SetAtt(33, 7);
SetAtt(34, 1);
SetAtt(35, 1);
SetAtt(36, 1);
SetAtt(37, 1);
SetAtt(38, 1);
SetAtt(39, 1);
SetExprAtt(40, [{Set next locations for pickup}
do(
 setatt(
  13,
  +(
   xabsloc(first(in(att(20,c),c)),model)-xabsloc(cs,model),
   /(xsize(first(in(att(20,c),c))),2)-0.5
  ),
  c
 ),
 setatt(
  15,
  +(
   yabsloc(first(in(att(20,c),c)),model)-yabsloc(cs,model),
   /(ysize(first(in(att(20,c),c))),2)-0.5
  ),
  c
 ),
 setatt(
  17,
  +(
   zabsloc(first(in(att(20,c),c)),model)-zabsloc(cs,model),
   zsize(first(in(att(20,c),c)))
  ),
  c
 )
)]);
SetExprAtt(41, [{Set locations for drop down position}
do(
 setatt(
  13,
  +(
   xabsloc(out(att(20,c),c),model)-xabsloc(cs,model),
   /(xsize(first(c)),2)-0.5,
   if(att(63,c),att(60,c))
  ),
  c
 ),
 setatt(
  15,
  +(
   yabsloc(out(att(20,c),c),model)-yabsloc(cs,model),
   /(ysize(first(c)),2)-0.5,
   if(att(63,c),att(61,c))
  ),
  c
 ),
 setatt(
  17,
  +(
   zabsloc(out(att(20,c),c),model)-zabsloc(cs,model),
   if(
    att(63,c),
    att(62,c),
    zsize(out(att(20,c),c))
   ),
   zsize(first(c))
  ),
  c
 )
)]);
SetAtt(42, 26);
SetExprAtt(43, [{.~1|~if(label([type],i)=1,1,
    if(label([type],i)=2,2


))~.}if(label([type],i)=1,1,
    if(label([type],i)=2,2


))]);
SetExprAtt(44, [{.if(=(sum(nric(c),if(atomexists(in(count,c)),*(ocopen(icocno(count,c),in(count,c)),content(in(count,c))),0)),0),openallic(c),openic(indexmax(nric(c),if(atomexists(in(count,c)),*(ocopen(icocno(count,c),in(count,c)),if(>(content(in(count,c)),0),-(time,entrytime(first(in(count,c)))),0)),0)),c))|3. Longest waiting: Accept product from the atom whose first product entered earliest (if all queues are empty then open all channels and wait).}if(=(sum(nric(c),if(atomexists(in(count,c)),*(ocopen(icocno(count,c),in(count,c)),content(in(count,c))),0)),0),openallic(c),openic(indexmax(nric(c),if(atomexists(in(count,c)),*(ocopen(icocno(count,c),in(count,c)),if(>(content(in(count,c)),0),-(time,entrytime(first(in(count,c)))),0)),0)),c))]);
SetExprAtt(45, [0]);
SetExprAtt(46, [0]);
SetExprAtt(47, [0]);
SetExprAtt(48, [0]);
SetAtt(49, 0);
SetExprAtt(50, [{.do(setatt(26,7,c),setatt(33,7,c),repeat(6,setatt(+(count,26),1,c)),repeat(6,setatt(+(count,33),1,c)))|1. All directions together (using Y-speed).}do(setatt(26,7,c),setatt(33,7,c),repeat(6,setatt(+(count,26),1,c)),repeat(6,setatt(+(count,33),1,c)))]);
SetExprAtt(51, [xsize(cs)/2]);
SetExprAtt(52, [ysize(cs)/2]);
SetExprAtt(53, [att([transport-height],c)]);
SetAtt(54, 0);
SetAtt(55, 1);
SetAtt(56, 0);
SetAtt(57, 1);
SetAtt(58, 0);
SetAtt(59, 1);
SetExprAtt(60, [0]);
SetExprAtt(61, [0]);
SetExprAtt(62, [0]);
SetAtt(63, 0);
SetAtt(64, 0);
SetAtt(65, 0);
SetAtt(66, 1);
int024;
SetStatus(0);
int018;
Up;
Up;
Up;


{Atom: Product1}

sets;
BaseClass;
CreateAtom(a, Up(s), [], 1, false);
int023([Product1], 12615680, 8402);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\product.bmp]), [product]));
AddModel3D(
	RegisterModel3D(Model3DDir([\box-closed.wrl]), [box-closed.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\box-opened.wrl]), [box-opened.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\pallet-wood.wrl]), [pallet-wood.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\pallet-plastic.wrl]), [pallet-plastic.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\oildrum.wrl]), [oildrum.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\crate.wrl]), [crate.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Product.ico]));
Set(Info, [A general product.

General
-----------
Put a product in your model and connect it's central channel 
with the input channel of a source to generate multiple instances 
of the product during running.

Notes:
---------
For cylinder shaped, horizontally oriented 3D icons set ySize 
equal to zSize.
For cylinder shaped, vertically oriented 3D icons set xSize 
equal to ySize.
For sphere set xSize equal to ySize and zSize.

Last revision:
------------------
September 27, 2003
]);
Set(DdbRec, [>t-nodestroy:1.]);
int001(186);
SetLoc(1, 13, 0);
SetSize(1, 1, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
CreateAttributes(2);
SetAttributeName(r(1), [Icon3D]);
SetAttributeName(r(2), [Hide2DIcon]);
SetAtt(r(1), 1);
SetAtt(r(2), 1);
int024;
Set(OnCreation, [{ In the OnInit event handler some edit fields are registered. }
{ This is ok for the product in the library tree, but not for the  }
{ products in the model, so erase the OnInit expression.       }
Set(OnInit, [])
]);
Set(OnReset, [If(
 Label( [t-nodestroy] , c) = 0,
 DestroyAtom
)
]);
Set(OnUser, [Do(
  { Delete any current instances of this form.} 
  GuiDestroy([Product]),

  { Register the GUI-form for this atom.}
  GuiRegister(PDir([\Atoms\Product.gui]), 1),

  { Show the GUI-form.}
   GuiCreate([Product], [Product], 0, c, 0, 1)
   )
]);
Set(On2DDraw, [if(
 c.DrawFlag,
 
 {--External atom(s) control product rotationas--}
 do(
  {--Variables for rotationas in order to compensate change of transportation direction--}
  RotateCoords(c.DrawRotationas, 0, 0, 1),
  
  {--Variables for translation in order to compensate change of transportation direction--}
  TranslateCoords(c.DrawXtranslate, c.DrawYtranslate, 0),
  
  {--Rotated shape--}
  dishape(0, 0 ,c.DrawXsize, c.DrawYsize, 0.01, ColorBlack, color(c))
 ),
 
 {--Standard--}
 do(
  c.DrawXsize := xSize(c),
  c.DrawYsize := ySize(c),
  diBmp(0, 0, Hide2DIcon * Icon(c), 1, 5)
 )
 
)
]);
Set(On3DDraw, [do(

 if(
  {--Product rotationas has been changed by external atom (e.g. Corner Transfer Unit)--}
  c.DrawFlag,
  do(
   {--Variables for rotationas in order to compensate change of transportation direction--}
   RotateCoords(c.DrawRotationas,0,0,1),
   
   {--Variables for translation in order to compensate change of transportation direction--}
   TranslateCoords(c.DrawXtranslate, c.DrawYtranslate,0)
  ),
  {--Standard--}
  do(
   c.DrawXsize := xSize(c),
   c.DrawYsize := ySize(c)
  )
 ),

 Case(
 Icon3D,
  {** Cube  **}
  di3DBox(0, 0, 0, c.DrawXsize, c.DrawYsize, zSize, Color),
  {**  Picture Cube **}
  di3DBox(0, 0, 0, c.DrawXsize, c.DrawYsize, zSize, Color, 0, 0, Icon, 0, 100, 100),
  {** Cylinder Horizontal **}
  Do(
   c.CenterPoint := Max(c.DrawYsize / 2, zSize / 2),
   Cylinder(0, c.CenterPoint, c.CenterPoint, c.DrawXsize, 360, c.CenterPoint, 0, 0, 0, Color)
  ),
  {** Cylinder Vertical **}
  Do(
   c.CenterPoint := Max(c.DrawXsize / 2, c.DrawYsize / 2),
   Cylinder(c.CenterPoint, c.CenterPoint, 0, zSize, 360, c.CenterPoint, 0, 90, 0, Color)
  ),
  {** Ball **}
  Do(
   c.CenterPoint := Max(c.DrawXsize / 2, Max(c.DrawYsize / 2, zSize / 2)),
   Ball( c.CenterPoint, c.CenterPoint, c.CenterPoint, c.CenterPoint, 180, 360, 0, 0, 0, Color)
  ),
  {** Cone **}
  Do(
   c.CenterPoint := Max(c.DrawXsize, c.DrawYsize),
   Cone(c.CenterPoint / 2, c.CenterPoint / 2, 0, zSize, c.CenterPoint / 2, 0, 0, 90, 0, Color)
  ),
  {** Barrel Horizontal **}
  Do(
   c.CenterPoint := Max(c.DrawYsize / 2, zSize / 2),
   Cylinder(0, c.CenterPoint, c.CenterPoint, c.DrawXsize, 360, c.CenterPoint, 0, 0, 0, Color),
   Cone(0, c.CenterPoint, c.CenterPoint, 0, c.CenterPoint, 0, 0, 0, 0, Color),
   Cone(c.DrawXsize, c.CenterPoint, c.CenterPoint, 0, c.CenterPoint, 0, 0, 0, 0, Color)
  ),
  {** Barrel Vertical **}
  Do(
   c.CenterPoint := Max(c.DrawXsize / 2, c.DrawYsize / 2),
   Cylinder(c.CenterPoint, c.CenterPoint, 0, zSize, 360, c.CenterPoint, 0, 90, 0, Color),
   Cone(c.CenterPoint, c.CenterPoint, zSize, 0, c.CenterPoint, 0, 0, 90, 0, Color),
   Cone(c.CenterPoint, c.CenterPoint, 0, 0, c.CenterPoint, 0, 0, 90, 0, Color)
  ),
  {** Pallet **}
  Do(
   di3DBox(0, 0, 0, c.DrawXsize, 0.1, zSize - 0.05, Color),
   di3DBox(0, /( c.DrawYsize, 2) - 0.05, 0, c.DrawXsize, 0.1, zSize - 0.05, Color),
   di3DBox(0, c.DrawYsize - 0.1, 0, c.DrawXsize, 0.1, zSize - 0.05, Color),
   c.CenterPoint := c.DrawXsize / 5,
   Repeat(
    5,
    di3DBox(Count * c.CenterPoint, 0, zSize - 0.05, -0.1, c.DrawYsize, 0.05, Color)
   )
  ),
  {** Simple Person **}
  Do(
   c.CenterPoint := c.DrawYsize / 2,
   {head} Ball( 0, c.CenterPoint, 1.8, 0.1, 180, 360, 0, -90 ,0, 7846395),
   {neck} Cylinder(0, c.CenterPoint, 1.65, 0.1, 360, 0.05, 0, 90, 0, 7846395),
   {shoulders}EllipseCone(0, c.CenterPoint, 1.52, 0.15, 360, 0.08, 0.05, 0.12, 0.2, 0, 90, 0, Color),
   {arm 1}  Cone(0, 0.15 + c.CenterPoint, 1.5, 0.5, 0.05, 0.02, 20, -80, 0, Color),
   {arm 2}  Cone(0, -0.15 + c.CenterPoint, 1.5, 0.5, 0.05, 0.02, 20, -80, 0, Color),
   {hand 1} Cone(0.08, -0.12 + c.CenterPoint, 1.02, 0.1, 0.02, 0.02, 20, -80, 0, 7846395),
   {hand 2}  Cone(0.08, 0.18 + c.CenterPoint, 1.02, 0.1, 0.02, 0.02, 20, -80, 0, 7846395),
   {body}  EllipseCone(0,c.CenterPoint, 1.07, 0.45, 360, 0.12, 0.2, 0.08, 0.1, 0, 90, 0, Color),
   {waist}  EllipseCone(0,c.CenterPoint, 0.92, 0.15, 360, 0.08, 0.1, 0.11, 0.15, 0, 90, 0, ColorGray),
   {leg 1}  Cone(0, 0.07 + c.CenterPoint, 0, 0.92, 0.03, 0.08, 0, 90, 0, ColorGray),
   {leg 2}  Cone(0, -0.07 + c.CenterPoint, 0, 0.92, 0.03, 0.08, 0, 90, 0, ColorGray),
   {foot 1}  EllipseCone(0, 0.07 + c.CenterPoint, 0,0.2, 180, 0.01, 0.03, 0.04, 0.05, 0, 0, 0, ColorBlack),
   {foot 2}  EllipseCone(0, -0.07 + c.CenterPoint, 0, 0.2, 180, 0.01, 0.03, 0.04, 0.05, 0, 0, 0, ColorBlack)
  ),
  {** Closed Carton Box **}
  DrawModel3D(Model3D(1, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Open Carton Box **}
  DrawModel3D(Model3D(2, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Pallet - Wood **}
  DrawModel3D(Model3D(3, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Pallet - Plastic **}
  DrawModel3D(Model3D(4, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Oildrum **}
  DrawModel3D(Model3D(5, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Crate **}
  DrawModel3D(Model3D(6, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize)
 )

)
]);
SetStatus(0);
int018;


{Atom: Source2}

sets;
AtomByName([Source], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Source'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([Source2], 7168771, 240);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\atoms\source.bmp]), [source]));
AddModel3D(
	RegisterModel3D(Model3DDir([\source.wrl]), [source.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\source_Resized.wrl]), [Source_Resized.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Source.ico]));
Set(DdbRec, [>t-node1:1.>t-network:1.]);
SetChannels(1, 1);
SetChannelRanges(1, 1, 1, 255);
int001(187);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(4, 12, 0);
SetSize(5, 2, 2);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [{.~1|~1~.}1]);
SetExprAtt(2, [NegExp(10)]);
SetExprAtt(3, [{.~1|~0~.}0]);
SetExprAtt(4, [0]);
SetExprAtt(5, [0]);
SetExprAtt(6, [{.~1|~100~.}100]);
SetAtt(7, 4);
int024;
SetStatus(2);
int018;


{Atom: q7}

sets;
AtomByName([Queue], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Queue'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([q7], 12615680, 1264);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\queue.bmp]), [queue]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Queue.ico]));
Set(DdbRec, [>t-node1:6.>t-network:1.]);
SetChannels(1, 1);
SetChannelRanges(1, 255, 1, 255);
int001(188);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(23, 10, 0);
SetSize(5, 2, 0);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [{.~1|1. Specific channel: always send to channel ~1~.}1]);
SetAtt(2, 1);
SetExprAtt(3, [Label([type],i):=1]);
SetExprAtt(4, [0]);
SetExprAtt(5, [{.content(c)|Fifo (First In First Out).}content(c)]);
SetAtt(6, 1.1);
SetExprAtt(7, [{.openallic(c)|Any inputchannel.}openallic(c)]);
SetAtt(8, 2);
int024;
SetStatus(13);
int018;


{Atom: g7}

sets;
AtomByName([Ground Storage], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Ground Storage'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([g7], 0, 240);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\buffers\warehouse.bmp]), [warehouse]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
AddTexture(
	RegisterTexture(IconsDir([Bmp\Buffers\warehouse.bmp]), [warehouse.bmp], 128, 64, 255, 255, 0, 0, 0, 0), a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\GroundStorage.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 255, 0, 255);
int001(190);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(23, 16, 0);
SetSize(4, 6, 0);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetAtt(1, 6);
SetAtt(2, 1);
SetAtt(3, 1);
SetAtt(4, 1);
SetExprAtt(5, [label([type],i):=2]);
SetExprAtt(6, [0]);
SetExprAtt(7, [label([row],i)]);
SetExprAtt(8, [label([column],i)]);
SetExprAtt(9, [{.if(=(sum(nric(c),if(atomexists(in(count,c)),*(ocopen(icocno(count,c),in(count,c)),content(in(count,c))),0)),0),openallic(c),openic(indexmax(nric(c),if(atomexists(in(count,c)),*(ocopen(icocno(count,c),in(count,c)),content(in(count,c))),0)),c))|2. Largest queue: Accept product from the atom with the largest queue (if all queues are empty then open all channels and wait).}if(=(sum(nric(c),if(atomexists(in(count,c)),*(ocopen(icocno(count,c),in(count,c)),content(in(count,c))),0)),0),openallic(c),openic(indexmax(nric(c),if(atomexists(in(count,c)),*(ocopen(icocno(count,c),in(count,c)),content(in(count,c))),0)),c))]);
SetExprAtt(10, [{.content(c)|Fifo (First In First Out).}content(c)]);
SetExprAtt(11, [{.~1|~1~.}1]);
SetExprAtt(12, [first(c)]);
SetAtt(13, 0);
SetAtt(14, 1);
SetAtt(15, 1);
SetAtt(16, 1);
SetAtt(17, 1);
int024;
SetTable(6, 1);
int015(0, 0, [ 
1
2
3
4
5
6
]);
int015(1, 0, [1
0
0
0
0
0
0
]);
SetStatus(15);
int018;


{Atom: Node Manipulator29}

sets;
AtomByName([Node Manipulator], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Node Manipulator'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([Node Manipulator29], 32768, 3106);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\tedatom.bmp]), [ed]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\NodeManipulator.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 1, 1, 1);
int001(211);
SetLoc(-2, 11, 0);
SetSize(2, 2, 0);
LockPosition(false);
LockSize(true);
DisableIconRotation(false);
SetProductCode([]);
SetAtt(1, 1);
SetExprAtt(2, [do(
 setatt(3,0,c),
 var([atmLP], vbAtom),

 ForAtomTreeUnder(
  Model,
  do(
   atmLP := a,
   if(
    and(
     >(max(xAbsLoc(atmLP, Model), +(xabsloc(atmLP, Model), xsize(atmLP))), xabsloc(c, Model)),
     >(max(yabsloc(atmLP, Model), +(yabsloc(atmLP, Model), ysize(atmLP))), yabsloc(c, Model)),
     <(min(xabsloc(atmLP, Model), +(xabsloc(atmLP, Model), xsize(atmLP))), +(xabsloc(c, Model), xsize(c))),
     <(min(yabsloc(atmLP, Model), +(yabsloc(atmLP, Model), ysize(atmLP))), +(yabsloc(c, Model),ysize(c))),
     <>(atomid(atmLP),atomid(c)),
     not(ddb([t999-hidenodes],atmLP))
    ),
    do(
     setatt(3,1,c),
     att([CurrentAtom], c) := ptv(atmLP)
    )
   )
  )
 )
)]);
SetAtt(3, 0);
SetAtt(4, 1);
SetAtt(5, 0);
SetExprAtt(6, [if(
 atomexists(in(1, c)),
 connect(0, c, 1, c)
)]);
SetAtt(7, 1);
SetAtt(8, 1);
SetAtt(9, 1);
SetAtt(10, 0);
SetAtt(11, 1);
SetAtt(12, 0);
int024;
SetStatus(0);
int018;


{Atom: Transporter21}

sets;
AtomByName([Transporter], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Transporter'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([Transporter21], 767720, 66643);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\Transport\truck2.bmp]), [truck 1]));
AddModel3D(
	RegisterModel3D(Model3DDir([\Forklift.wrl]), [Forklift.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Transporter1.ico]));
SetChannels(1, 3);
SetChannelRanges(1, 255, 1, 255);
int001(212);
int013(1, 0, true, false, 0, 0, [], []);
int013(2, 0, true, false, 0, 0, [], []);
int013(3, 0, true, false, 0, 0, [], []);
SetLoc(23, 10, 0);
SetSize(3, 2, 1);
Set(RotationAs, 165.963756532074);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetAtt(1, 1);
SetAtt(2, 1);
SetAtt(3, 0);
SetAtt(4, 0);
SetAtt(5, 0);
SetAtt(6, 0);
SetAtt(7, 1);
SetExprAtt(8, [{.openallic(c)|Any inputchannel.}openallic(c)]);
SetAtt(9, 1);
SetExprAtt(10, [0]);
SetExprAtt(11, [0]);
SetExprAtt(12, [{.~1|1. Specific channel: always send to channel ~1~.}1]);
SetExprAtt(13, [0]);
SetExprAtt(14, [0]);
SetExprAtt(15, [0]);
SetExprAtt(16, [0]);
int024;
SetStatus(1);
int018;


{Atom: Sink23}

sets;
AtomByName([Sink], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Sink'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([Sink23], 7168771, 240);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\Atoms\sink.bmp]), [sink]));
AddModel3D(
	RegisterModel3D(Model3DDir([\sink.wrl]), [sink.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\sink_Resized.wrl]), [sink_Resized.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Sink.ico]));
SetChannels(1, 0);
SetChannelRanges(1, 255, 0, 0);
int001(213);
int013(1, 0, true, true, 0, 0, [], []);
SetLoc(23, 34, 0);
SetSize(5, 2, 2);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetAtt(1, 0);
SetAtt(2, 4);
int024;
SetStatus(1);
int018;


{Atom: Copy of Transporter21}

sets;
AtomByName([Transporter], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Transporter'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([Copy of Transporter21], 767720, 66643);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\Transport\truck2.bmp]), [truck 1]));
AddModel3D(
	RegisterModel3D(Model3DDir([\Forklift.wrl]), [Forklift.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Transporter1.ico]));
SetChannels(3, 1);
SetChannelRanges(1, 255, 1, 255);
int001(214);
int013(1, 0, true, false, 0, 0, [], []);
int013(2, 0, true, true, 0, 0, [], []);
int013(3, 0, true, true, 0, 0, [], []);
SetLoc(23, 34, 0);
SetSize(3, 3, 1);
Set(RotationAs, -56.8214883406073);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetAtt(1, 1);
SetAtt(2, 1);
SetAtt(3, 0);
SetAtt(4, 0);
SetAtt(5, 0);
SetAtt(6, 0);
SetAtt(7, 1);
SetExprAtt(8, [{.openallic(c)|Any inputchannel .}openallic(c)]);
SetAtt(9, 1);
SetAtt(10, 0);
SetAtt(11, 0);
SetExprAtt(12, [1]);
SetExprAtt(13, [0]);
SetExprAtt(14, [0]);
SetAtt(15, 0);
SetAtt(16, 0);
int024;
SetStatus(1);
int018;


{Atom: Queue24}

sets;
AtomByName([Queue], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Queue'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([Queue24], 12615680, 1264);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\queue.bmp]), [queue]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Queue.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 255, 1, 255);
int001(215);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(23, 25, 0);
SetSize(5, 2, 0);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [1]);
SetAtt(2, 10);
SetAtt(3, 0);
SetAtt(4, 0);
SetExprAtt(5, [{.content(c)|Fifo (First In First Out) .}content(c)]);
SetAtt(6, 5);
SetExprAtt(7, [{.openallic(c)|Any inputchannel .}openallic(c)]);
SetAtt(8, 2);
int024;
SetStatus(13);
int018;
Up;
int014(1, 187, 1, 212, 0);
int014(0, 186, 1, 187, 0);
int014(1, 188, 1, 222, 0);
int014(1, 212, 1, 188, 0);
int014(1, 190, 2, 222, 0);
int014(1, 222, 1, 190, 0);
int014(1, 214, 1, 213, 0);
int014(1, 215, 1, 214, 0);
int014(2, 222, 1, 215, 0);
int006(0, 222, 16, 0, 0);
int006(0, 187, 1, 0, 0);


{Experiment settings}

int034;
int007;
